#include "mbed.h"

#ifndef __MLX_h
#define __MLX_h
#define EEPROM 0x10
#define RAM 0x20
    
extern DigitalOut MLX_VCC;

class Mlx90615
{
public:
    void wake();
    void sleep();
    float read_temperature();
    void erase_eeprom_address(unsigned char address);
    void set_emissivity(float e);
private:
    float read(unsigned char memory, unsigned char address);
    void write(unsigned char address, unsigned int value);
};

#endif // __MLX_h